<?php

namespace Model;

class CoachAthlete extends Coach {
    private array $trainingsList = [];
    public function getUsersList(): ?array {
        if (!empty($this->usersList)) {
            return $this->usersList;
        }
        return null;
    }
    public function getUserList(User $user): User {
        foreach ($this->usersList as $existingUser) {
            if ($existingUser->getId() === $user->getId()) {
                return $user; // L'utilisateur est présent dans la liste
            }
        }
        return null; // L'utilisateur n'est pas dans la liste
    }
    public function getTrainingsList(): ?array {
        if (!empty($this->trainingsList)) {
            return $this->trainingsList;
        }
        return null;
    }
    public function getTrainingList(Training $training): ?Training {
        foreach ($this->trainingsList as $existingTraining) {
            if ($existingTraining->getId() === $training->getId()) {
                return $training; // L'utilisateur est présent dans la liste
            }
        }
        return null; // L'utilisateur n'est pas dans la liste
    }
    public function CheckAdd(User $user) : bool {
        if($user->getRole() instanceof \Model\Athlete){
            return true;
        }
        return false;
    }
    public function CheckAddTraining(Training $training) : bool {
        if($training instanceof \Model\Training){
            return true;
        }
        return false;
    }
    public function addUser(User $user): bool {
        if($this->CheckAdd($user)){
            array_push($this->usersList, $user);
            return true;
        }
        return false;
    }
    public function removeUser(User $user): bool {
        if($this->CheckAdd($user)){
            $key = array_search($user, $this->usersList);
            if ($key !== false) {
                array_splice($this->usersList, $key, 1);
            }
            return true;
        }
        return false;
    }
    public function addTraining(Training $training): bool {
        if($this->CheckAddTraining($training)){
            array_push($this->trainingsList, $training);
            return true;
        }
        return false;
    }
    public function removeTraining(Training $training): bool {
        if($this->CheckAddTraining($training)){
            $key = array_search($training, $this->trainingsList);
            if ($key !== false) {
                array_splice($this->trainingsList, $key, 1);
            }
            return true;
        }
        return false;
    }
}